﻿Imports System.IO.Ports

Public Class Form1
    Private Const EXE_CMD As String = "R" & vbCrLf ' 実行コマンド（プログラムを実行する）
    Private Const EXE_PAUSE As String = Chr(&H3)  ' 中断コマンド（ラダーを中断しプロンプトを表示、コマンド待ち）
    Private Const EXE_RESTART As String = Chr(&H1)    ' ラダーを再開コマンド
    Private Const EXE_RESET As String = Chr(&H0)  ' リセットコマンド
    Private Const EXE_VIEW As String = "V" & vbCrLf   ' システム情報表示コマンド

    Private Const SET_AD4 As String = "X04A" & vbCrLf
    Private Const SET_AD5 As String = "X05A" & vbCrLf
    Private Const SET_DI4 As String = "X04D" & vbCrLf
    Private Const SET_DI5 As String = "X05D" & vbCrLf

    Private Const GET_LIST As String = "L" & vbCrLf   ' メモリー上のラダーニーモニックを表示する
    Private Const GET_LIST_NUM As String = "L"      ' 指定した行以降を表示する
    Private Const PG_SET As String = "" & vbCrLf
    Private Const PG_INS As String = "I" & vbCrLf

    Private Const DEV_X_VAL As Integer = 0
    Private Const DEV_Y_VAL As Integer = 1
    Private Const DEV_M_VAL As Integer = 2
    Private Const DEV_D_VAL As Integer = 3
    Private Const DEV_T_VAL As Integer = 4
    Private Const DEV_C_VAL As Integer = 5

    Private Enum MODE
        TIMER
        OPEN
        CLOSE
    End Enum

    '    Dim RecvDataBuffer(1024) As Byte
    '    Dim ReadPos As Integer
    Dim RecvPos As Integer
    Dim CrFlag As Boolean
    Dim DeviceFlag As Integer
    Dim RecvData As String

    ' フォーム読み込み時のイベント
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        PortSearch() ' ポートを探して、ComboBoxに追加する
        EnableSet(MODE.CLOSE)
    End Sub
    ' フォームを閉じた時のイベント
    Private Sub Form1_Closed(sender As Object, e As EventArgs) Handles Me.Closed
        If (SerialPort1.IsOpen()) Then
            SerialPort1.Close()
        End If
    End Sub


    ' シリアルポートデータ受信イベントプロシージャ  
    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim recvByte As Byte() = New Byte(SerialPort1.BytesToRead - 1) {} '受信バッファー内のデータの配列を生成
        ' SerialPort の入力バッファーからデータのバイト数を読み取り  
        SerialPort1.Read(recvByte, 0, recvByte.GetLength(0))
        ' 
        Dim analyze As New AnalyzeTextDelegate(AddressOf AnalyzeText)
        ' 受信データ（バイト）配列をＳＨＩＦＴＪＩＳに変換
        Dim recvStr As String = System.Text.Encoding.GetEncoding("SHIFT-JIS").GetString(recvByte)
        ' デリゲートを呼び出す部分
        Me.Invoke(analyze, New Object() {recvStr})
    End Sub

    ' 受信データをＵＩで使用するためのデリゲート
    Delegate Sub AnalyzeTextDelegate(ByVal strDisp As String)

    '受信文字の解析サブプロシージャ  
    Private Sub AnalyzeText(ByVal strDisp As String)
        Dim tempstr As String
        RecvData &= strDisp
        Dim delimpos As Integer = RecvData.IndexOf(vbCrLf)  ' 受信データのＣＲＬＦを検索
        Try
            ' 受信データに終端文字が含まれている間
            While (delimpos >= 0)
                Dim strmsg As String = RecvData.Substring(0, delimpos) ' ＣＲＬＦまでのデータ取り出し
                RichTextBox1.Text &= RecvData.Substring(0, delimpos) & vbCrLf

                RecvData = RecvData.Substring(delimpos + 2) ' ＣＲＬＦの次から取り出し
                delimpos = RecvData.IndexOf(vbCrLf)         ' 受信データのＣＲＬＦを検索

                ' 受信文字が５文字以上の時
                If (strmsg.Length >= 5) Then
                    Dim buf As String() = strmsg.Substring(3).Split(" ") ' スペースでデータを分割
                    Dim bbuf As String
                    Dim i As Integer
                    Dim j As Integer

                    If (strmsg(2) = ":") Then ' 2番目の文字が「:」の時
                        Select Case strmsg(1) ' 1番目の文字をチェック
                            Case "X" ' 
                                ListBox1.Items.Add(strmsg.Substring(3))
                                ' 文字列からビットのＯＮ／ＯＦＦ情報の取得
                                bbuf = buf(0)
                                'ListBox1.Items.Add("X00:" & bbuf(7))
                                'ListBox1.Items.Add("X01:" & bbuf(6))
                                'ListBox1.Items.Add("X02:" & bbuf(5))
                                'ListBox1.Items.Add("X03:" & bbuf(4))
                                'ListBox1.Items.Add("X04:" & bbuf(3))
                                'ListBox1.Items.Add("X05:" & bbuf(2))
                                'ListBox1.Items.Add("X06:" & bbuf(1))
                                'ListBox1.Items.Add("X07:" & bbuf(0))
                                For i = 0 To 7
                                    ListBox1.Items.Add("X0" & i & ":" & bbuf(7 - i))
                                Next
                            Case "Y"
                                ListBox2.Items.Add(strmsg.Substring(3))
                                ' 文字列からビットのＯＮ／ＯＦＦ情報の取得
                                bbuf = buf(0)
                                'ListBox2.Items.Add("Y00:" & bbuf(7))
                                'ListBox2.Items.Add("Y01:" & bbuf(6))
                                'ListBox2.Items.Add("Y02:" & bbuf(5))
                                'ListBox2.Items.Add("Y03:" & bbuf(4))
                                'ListBox2.Items.Add("Y04:" & bbuf(3))
                                'ListBox2.Items.Add("Y05:" & bbuf(2))
                                For i = 0 To 5
                                    ListBox2.Items.Add("Y0" & i & ":" & bbuf(7 - i))
                                Next
                            Case "M"
                                ListBox3.Items.Add(strmsg.Substring(3))
                                j = 0
                                ' 文字列からビットのＯＮ／ＯＦＦ情報の取得
                                For Each m_data In buf
                                    For i = 0 To 7
                                        ListBox3.Items.Add("M" & (j * 8 + i) & ":" & m_data(7 - i))
                                    Next
                                    j += 1
                                Next
                            Case "D"
                                ListBox4.Items.Add(strmsg.Substring(3))

                                Dim fpos As Integer = 0
                                Dim npos As Integer = strmsg.IndexOf(")")
                                Dim HexData As String

                                For i = 0 To 7
                                    fpos = strmsg.IndexOf("(", fpos + 1)
                                    HexData = strmsg.Substring(fpos - 4, 4)
                                    ListBox4.Items.Add("D0" & i & ":" & Convert.ToInt32(HexData, 16))
                                Next

                            Case "T"
                                ListBox5.Items.Add(strmsg.Substring(3))
                                bbuf = buf(0)
                                For j = 0 To 1
                                    For i = 0 To 7
                                        ListBox5.Items.Add("T" & (j * 8 + i) & ":" & bbuf(7 - i))
                                    Next
                                Next

                            Case "C"
                                ListBox6.Items.Add(strmsg.Substring(3))
                                bbuf = buf(0)
                                For i = 0 To 7
                                    ListBox6.Items.Add("C" & (i) & ":" & bbuf(7 - i))
                                Next
                            Case Else

                        End Select
                    ElseIf (strmsg(4) = ":") Then
                        Label9.Text = strmsg.Substring(1, 1) & strmsg.Substring(2, 2) & ":" & strmsg.Substring(5)
                        Select Case strmsg.Substring(1, 1)
                            Case "X"
                                Label19.Text = strmsg.Substring(5)
                            Case "Y"
                                Label19.Text = strmsg.Substring(5)
                            Case "M"
                                Label19.Text = strmsg.Substring(5)
                            Case "D"
                                Dim fpos As Integer = strmsg.IndexOf("(")
                                Dim npos As Integer = strmsg.IndexOf(")")
                                Label19.Text = strmsg.Substring(5, 4) & ":" & strmsg.Substring(fpos + 1, npos - fpos - 1)
                                ListBox4.Items.Add(Label9.Text)
                            Case "T"
                                Label19.Text = strmsg.Substring(5)
                            Case "C"
                                Label19.Text = strmsg.Substring(5)
                            Case Else

                        End Select
                    End If
                Else

                End If
            End While

            ' ＣＲＬＦがなく、受信データが２文字のみの時
            If (RecvData.Count = 2) Then
                ' R> の時は、実行中の待機中
                If (RecvData = "R>") Then
                    RichTextBox1.Text &= "R>"
                    RecvData = ""
                End If
            End If

            ' ＣＲＬＦがなく、受信データが１文字のみの時
            If (RecvData.Count = 1) Then
                ' > の時は、停止中の待機中
                If (RecvData = ">") Then
                    RichTextBox1.Text &= ">"
                    RecvData = ""
                End If
            End If
            If (RichTextBox1.Text.Length > 1000) Then
                Dim buf As String = RichTextBox1.Text
                Dim pos As Integer = buf.IndexOf(vbLf)
                If (pos >= 0) Then
                    RichTextBox1.Text = buf.Substring(pos + 1)
                End If
            End If
            ' RichTextBox1の表示位置を末尾に変更する
            RichTextBox1.SelectionStart = RichTextBox1.Text.Length
            RichTextBox1.ScrollToCaret()
        Catch ex As ArgumentException
            MessageBox.Show(ex.ToString())
            'Catch ex As Exception
            '    MessageBox.Show(ex.ToString())
        End Try
    End Sub

    ' ポートを開くボタンのクリックイベントプロシージャ
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If (ComboBox1.Items.Count <= 0) Then
            MessageBox.Show("使用できるポートがありません。ドライバが入っていないか、ほかのソフトで使用中です。")
            Return
        End If
        If (SerialPort1.IsOpen() = False) Then ' ポートが開いているかどうかのチェック
            SerialPort1.PortName = ComboBox1.Text
            SerialPort1.Open()  ' ポートを開く

            RichTextBox1.Text = ""  ' 通信履歴のRichTextBox1
            RecvData = ""           '  受信データをクリアする
            RecvPos = 0
            CrFlag = False          ' ＣＲＬＦ受信データフラグをクリア

            EnableSet(MODE.OPEN)    ' ウィンドウの設定を変更する
        Else
            MessageBox.Show("すでにポートがオープンされています。")
        End If
    End Sub

    ' ポートを閉じるボタンのクリックイベントプロシージャ
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen()) Then
            '           Timer1.Stop()               ' タイマーをストップ
            RecvData = ""               ' 受信データをクリアする
            SerialPort1.Close()         ' シリアルポートを閉じる
        End If
        EnableSet(MODE.CLOSE)       ' ウィンドウの設定を変更する
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim buf As String
        Select Case DeviceFlag
            Case DEV_X_VAL
                ListBox1.Items.Clear()
                buf = "X?" & vbCrLf
            Case DEV_Y_VAL
                ListBox2.Items.Clear()
                buf = "Y?" & vbCrLf
            Case DEV_M_VAL
                ListBox3.Items.Clear()
                buf = "M?" & vbCrLf
            Case DEV_D_VAL
                ListBox4.Items.Clear()
                'buf = "D00?" & vbCrLf
                'buf &= "D01?" & vbCrLf
                'buf &= "D02?" & vbCrLf
                'buf &= "D03?" & vbCrLf
                'buf &= "D04?" & vbCrLf
                'buf &= "D05?" & vbCrLf
                'buf &= "D06?" & vbCrLf
                'buf &= "D07?" & vbCrLf
                buf = "D?" & vbCrLf
            Case DEV_T_VAL
                ListBox5.Items.Clear()
                buf = "T?" & vbCrLf
            Case DEV_C_VAL
                ListBox6.Items.Clear()
                buf = "C?" & vbCrLf
            Case Else
                buf = ""
        End Select

        If (buf <> "") Then
            SerialPort1.Write(buf)
        End If

        DeviceFlag = DeviceFlag + 1

        If (DeviceFlag > DEV_C_VAL) Then
            DeviceFlag = DEV_X_VAL
        End If
    End Sub

    ' ポートサーチのボタンクリックイベント
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        ' ポートを探し、コンボボックスに表示する
        PortSearch()
    End Sub

    ' 送信ボタンのクリックイベント
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write(TextBox1.Text & vbCrLf)   ' データを送信する
            TextBox1.Text = ""  ' TextBox1の表示文字をクリアする
            TextBox1.Focus()    ' 連続入力のためにフォーカスをセットする
        End If
    End Sub
    ' 実行ボタンクリックイベント
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("R" & vbCrLf) ' 実行コマンドを送信（Ｒ）
        End If
    End Sub
    ' 中断ボタンクリックイベント
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            Dim Data As Byte() = {&H3}      ' ^C　の送信 
            SerialPort1.Write(Data, 0, 1)
        End If

    End Sub
    ' 再開ボタンクリックイベント
    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            Dim Data As Byte() = {&H1}      ' 未サポートの命令（当初サポートだが、途中で未サポートとなる）
            SerialPort1.Write(Data, 0, 1)
        End If
    End Sub
    ' リセットボタンクリックイベント
    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("@" & vbCrLf) ' 実行コマンドを送信（@）
        End If
    End Sub

    ' Y00 をクリックしてチェック状態が変わった時のイベント
    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox1.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y00=1" & vbCrLf) ' Y00をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y00=0" & vbCrLf) ' Y00をＯＦＦのコマンド送信
            End If
        End If

    End Sub

    ' Y01 をクリックしてチェック状態が変わった時のイベント
    Private Sub CheckBox2_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox2.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y01=1" & vbCrLf) ' Y01をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y01=0" & vbCrLf) ' Y01をＯＦＦのコマンド送信
            End If
        End If

    End Sub

    ' Y02 をクリックしてチェック状態が変わった時のイベント
    Private Sub CheckBox3_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox3.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y02=1" & vbCrLf) ' Y02をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y02=0" & vbCrLf) ' Y02をＯＦＦのコマンド送信
            End If
        End If
    End Sub

    ' Y03 をクリックしてチェック状態が変わった時のイベント
    Private Sub CheckBox4_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox4.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y03=1" & vbCrLf) ' Y03をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y03=0" & vbCrLf) ' Y03をＯＦＦのコマンド送信
            End If
        End If
    End Sub

    ' Y04 をクリックしてチェック状態が変わった時のイベント
    Private Sub CheckBox5_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox5.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y04=1" & vbCrLf) ' Y04をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y4=0" & vbCrLf) ' Y04をＯＦＦのコマンド送信
            End If
        End If
    End Sub

    ' Y05 をクリックしてチェック状態が変わった時のイベント
    Private Sub CheckBox6_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox6.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y05=1" & vbCrLf) ' Y05をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("Y5=0" & vbCrLf) ' Y05をＯＦＦのコマンド送信
            End If
        End If
    End Sub

    ' システム情報表示コマンド クリックイベント
    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("V" & vbCrLf) ' Vコマンドの送信
        End If
    End Sub

    ' X04A クリックイベント
    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X04A" & vbCrLf) ' X04をアナログ入力に変更
        End If
    End Sub
    ' X05A クリックイベント
    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X05A" & vbCrLf) ' X05をアナログ入力に変更
        End If
    End Sub

    ' X04D クリックイベント
    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles Button13.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X04D" & vbCrLf) ' X04をデジタル入力に変更
        End If
    End Sub

    ' X05D クリックイベント
    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles Button12.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X05D" & vbCrLf) ' X05をデジタル入力に変更
        End If
    End Sub

    ' X問合せボタンクリックイベント
    Private Sub Button14_Click(sender As Object, e As EventArgs) Handles Button14.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            ListBox1.Items.Clear()              'Xのリストをクリアする
            SerialPort1.Write("X?" & vbCrLf)    'X? コマンド送信
        End If
    End Sub

    ' Y問合せボタンクリックイベント
    Private Sub Button15_Click(sender As Object, e As EventArgs) Handles Button15.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            ListBox2.Items.Clear()              'Yのリストをクリアする
            SerialPort1.Write("Y?" & vbCrLf)    'Y? コマンド送信
        End If
    End Sub

    ' M問合せボタンクリックイベント
    Private Sub Button16_Click(sender As Object, e As EventArgs) Handles Button16.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            ListBox3.Items.Clear()              'Mのリストをクリアする
            SerialPort1.Write("M?" & vbCrLf)    'M? コマンド送信
        End If
    End Sub

    ' D問合せボタンクリックイベント
    Private Sub Button17_Click(sender As Object, e As EventArgs) Handles Button17.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            ListBox4.Items.Clear()              ' Dのリストをクリアする
            SerialPort1.Write("D?" & vbCrLf)    ' D? コマンド送信
            SerialPort1.Write("D00?" & vbCrLf)  ' D00? コマンド送信
            SerialPort1.Write("D01?" & vbCrLf)  ' D01? コマンド送信
            SerialPort1.Write("D02?" & vbCrLf)  ' D02? コマンド送信
            SerialPort1.Write("D03?" & vbCrLf)  ' D03? コマンド送信
            SerialPort1.Write("D04?" & vbCrLf)  ' D04? コマンド送信
            SerialPort1.Write("D05?" & vbCrLf)  ' D05? コマンド送信
            SerialPort1.Write("D06?" & vbCrLf)  ' D06? コマンド送信
            SerialPort1.Write("D07?" & vbCrLf)  ' D07? コマンド送信
        End If
    End Sub

    ' T問合せボタンクリックイベント
    Private Sub Button18_Click(sender As Object, e As EventArgs) Handles Button18.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            ListBox5.Items.Clear()              ' Tのリストをクリアする
            SerialPort1.Write("T?" & vbCrLf)    ' T? コマンド送信
        End If
    End Sub

    ' C問合せボタンクリックイベント
    Private Sub Button19_Click(sender As Object, e As EventArgs) Handles Button19.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            ListBox6.Items.Clear()              ' Cのリストをクリアする
            SerialPort1.Write("C?" & vbCrLf)    ' C? コマンド送信
        End If
    End Sub

    ' 削除 ボタンクリックイベント
    Private Sub Button20_Click(sender As Object, e As EventArgs) Handles Button20.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("NA" & vbCrLf)    ' NAコマンドの送信
        End If
    End Sub

    ' D00=0 ボタンクリックイベント
    Private Sub Button21_Click(sender As Object, e As EventArgs) Handles Button21.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("D00=0" & vbCrLf) ' D00を0にセットする
        End If
    End Sub

    ' D00=100 ボタンクリックイベント
    Private Sub Button22_Click(sender As Object, e As EventArgs) Handles Button22.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("D00=100" & vbCrLf) ' D00を100にセットする
        End If
    End Sub

    ' D01=x1F ボタンクリックイベント
    Private Sub Button23_Click(sender As Object, e As EventArgs) Handles Button23.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("D01=x1F" & vbCrLf) ' D01を0x1Fにセットする
        End If
    End Sub

    ' D01=x00 ボタンクリックイベント
    Private Sub Button24_Click(sender As Object, e As EventArgs) Handles Button24.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("D01=x00" & vbCrLf) ' D01を0x00にセットする
        End If
    End Sub

    ' リスト要求ボタンクリックイベント
    Private Sub Button25_Click(sender As Object, e As EventArgs) Handles Button25.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("L" & vbCrLf) ' L リスト要求コマンドの送信
        End If
    End Sub

    ' D00?ボタンクリックイベント
    Private Sub Button26_Click(sender As Object, e As EventArgs) Handles Button26.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("D00?" & vbCrLf) ' D00? 要求コマンドの送信
        End If
    End Sub

    ' D01?ボタンクリックイベント
    Private Sub Button27_Click(sender As Object, e As EventArgs) Handles Button27.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("D01?" & vbCrLf) ' D01? 要求コマンドの送信
        End If
    End Sub

    ' Y00?ボタンクリックイベント
    Private Sub Button28_Click(sender As Object, e As EventArgs) Handles Button28.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("Y00?" & vbCrLf) ' Y00? 要求コマンドの送信
        End If
    End Sub

    ' Y01?ボタンクリックイベント
    Private Sub Button29_Click(sender As Object, e As EventArgs) Handles Button29.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("Y01?" & vbCrLf) ' Y01? 要求コマンドの送信
        End If
    End Sub

    ' Y02?ボタンクリックイベント
    Private Sub Button30_Click(sender As Object, e As EventArgs) Handles Button30.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("Y02?" & vbCrLf) ' Y02? 要求コマンドの送信
        End If
    End Sub

    ' コマンド入力部分で文字を入力したとき
    Private Sub TextBox1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TextBox1.KeyPress
        If (e.KeyChar = vbCr) Then ' エンターキーが押されたとき
            Button4.PerformClick() ' 送信ボタンクリックイベント呼び出し
        End If
    End Sub

    ' D02?ボタンクリックイベント
    Private Sub Button31_Click(sender As Object, e As EventArgs) Handles Button31.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("D02?" & vbCrLf) ' D02? 要求コマンドの送信
        End If
    End Sub

    ' T02?ボタンクリックイベント
    Private Sub Button34_Click(sender As Object, e As EventArgs) Handles Button34.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("T02?" & vbCrLf) ' T02? 要求コマンドの送信
        End If
    End Sub

    ' T01?ボタンクリックイベント
    Private Sub Button33_Click(sender As Object, e As EventArgs) Handles Button33.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("T01?" & vbCrLf) ' T01? 要求コマンドの送信
        End If
    End Sub

    ' T00?ボタンクリックイベント
    Private Sub Button32_Click(sender As Object, e As EventArgs) Handles Button32.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("T00?" & vbCrLf) ' T00? 要求コマンドの送信
        End If
    End Sub

    ' C01?ボタンクリックイベント
    Private Sub Button36_Click(sender As Object, e As EventArgs) Handles Button36.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("C01?" & vbCrLf) ' C01? 要求コマンドの送信
        End If
    End Sub

    ' C02?ボタンクリックイベント
    Private Sub Button37_Click(sender As Object, e As EventArgs) Handles Button37.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("C02?" & vbCrLf) ' C02? 要求コマンドの送信
        End If
    End Sub

    ' C00?ボタンクリックイベント
    Private Sub Button35_Click(sender As Object, e As EventArgs) Handles Button35.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("C00?" & vbCrLf) ' C00? 要求コマンドの送信
        End If
    End Sub

    ' M00ボタンクリックイベント
    Private Sub CheckBox7_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox7.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("M00=1" & vbCrLf) ' M00をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("M00=0" & vbCrLf) ' M00をＯＦＦのコマンド送信
            End If
        End If
    End Sub

    ' M01ボタンクリックイベント
    Private Sub CheckBox8_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox8.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("M01=1" & vbCrLf) ' M01をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("M01=0" & vbCrLf) ' M01をＯＦＦのコマンド送信
            End If
        End If
    End Sub

    ' M02ボタンクリックイベント
    Private Sub CheckBox9_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox9.CheckedChanged
        Dim chkbtn As CheckBox
        chkbtn = TryCast(sender, CheckBox)
        If (chkbtn.Checked = True) Then
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("M02=1" & vbCrLf) ' M02をＯＮのコマンド送信
            End If
        Else
            If (SerialPort1.IsOpen() = True) Then
                SerialPort1.Write("M02=0" & vbCrLf) ' M02をＯＦＦのコマンド送信
            End If
        End If
    End Sub

    ' ポートの調べて、ＤＩＰＰＬＣが見つかったら、コンボボックスの一覧に追加する
    Private Sub PortSearch()
        Dim i As Integer
        Dim buf As String

        If (SerialPort1.IsOpen() = False) Then ' ポートが開いているかどうかのチェック
            ComboBox1.Items.Clear()            ' 通信ポートの一覧のコンボボックスの一覧クリア

            SerialPort1.BaudRate = 9600                 ' 通信速度を設定
            SerialPort1.StopBits = 1                    ' ストップビットの設定
            SerialPort1.Parity = IO.Ports.Parity.None   ' パリティビットの設定（なし）
            SerialPort1.ReceivedBytesThreshold = 256    ' イベントを発生させる受信データサイズを256にする
            SerialPort1.RtsEnable = False               ' ＲＴＳ信号を使用しない
            SerialPort1.Handshake = IO.Ports.Handshake.XOnXOff  ' ＸＯＮ－ＯＦＦのハンドシェイク
            SerialPort1.NewLine = vbCrLf                ' 終端文字をＣＲ・ＬＦにする
            SerialPort1.ReadTimeout = 500               ' 受信タイムアウトを500msに設定する

            ' COM1～COM15までを通信してみて返事が返ってくれば
            For i = 1 To 15
                SerialPort1.PortName = "COM" & i   ' ポート名を設定
                Try
                    SerialPort1.Open()  ' ポートを開く
                    SerialPort1.Write("R" & vbCrLf) ' 実行コマンドを送信してみる。
                    System.Threading.Thread.Sleep(100)  ' 応答待ち100ms
                    buf = SerialPort1.ReadLine()        ' 終端文字までデータが飛んでくれば
                    If ((buf = "R") Or (buf = ">")) Then    ' 返信が返ってくれば（”Ｒ＞”）
                        ComboBox1.Items.Add("COM" & i)      '
                    End If
                    SerialPort1.ReadExisting()
                Catch ex As System.IO.IOException

                Catch ex As System.UnauthorizedAccessException
                    MessageBox.Show("「COM" & i & "」ポートが他のソフトウェアで使用中の可能性があります。")
                Catch ex As System.Exception
                    '                    MessageBox.Show(ex.ToString())
                Finally
                    SerialPort1.Close() ' ポートを閉じる

                End Try
            Next
            If ComboBox1.Items.Count > 0 Then   ' 使用できるポートが１つでもあれば
                ComboBox1.SelectedIndex = 0     ' 最初のポート番号を選択する
            End If
            SerialPort1.ReceivedBytesThreshold = 1  ' 受信イベントを1バイトで発生に設定
        Else
            MessageBox.Show("すでにポートがオープンされています。")
        End If
    End Sub

    ' M02?ボタンクリックイベント
    Private Sub Button40_Click(sender As Object, e As EventArgs) Handles Button40.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("M02?" & vbCrLf) ' M02? 要求コマンドの送信 
        End If
    End Sub

    ' M01?ボタンクリックイベント
    Private Sub Button39_Click(sender As Object, e As EventArgs) Handles Button39.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("M01?" & vbCrLf)  ' M01? 要求コマンドの送信 
        End If
    End Sub

    ' M00?ボタンクリックイベント
    Private Sub Button38_Click(sender As Object, e As EventArgs) Handles Button38.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("M00?" & vbCrLf)  ' M00? 要求コマンドの送信 
        End If
    End Sub

    ' X00?ボタンクリックイベント
    Private Sub Button41_Click(sender As Object, e As EventArgs) Handles Button41.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X00?" & vbCrLf)  ' M00? 要求コマンドの送信 
        End If
    End Sub

    ' X01?ボタンクリックイベント
    Private Sub Button42_Click(sender As Object, e As EventArgs) Handles Button42.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X01?" & vbCrLf) ' X01? 要求コマンドの送信 
        End If
    End Sub
    ' X02?ボタンクリックイベント
    Private Sub Button43_Click(sender As Object, e As EventArgs) Handles Button43.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X02?" & vbCrLf) ' X02? 要求コマンドの送信 
        End If
    End Sub

    ' X03?ボタンクリックイベント
    Private Sub Button46_Click(sender As Object, e As EventArgs) Handles Button46.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X03?" & vbCrLf) ' X03? 要求コマンドの送信 
        End If
    End Sub

    ' X04?ボタンクリックイベント
    Private Sub Button45_Click(sender As Object, e As EventArgs) Handles Button45.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X04?" & vbCrLf) ' X04? 要求コマンドの送信 
        End If
    End Sub

    ' X05?ボタンクリックイベント
    Private Sub Button44_Click(sender As Object, e As EventArgs) Handles Button44.Click
        ' 通信ポートが開いているときのみ実行
        If (SerialPort1.IsOpen() = True) Then
            SerialPort1.Write("X05?" & vbCrLf) ' X05? 要求コマンドの送信 
        End If
    End Sub

    ' ウィンドウの設定（有効・無効）をモードによって切り替える
    Private Sub EnableSet(ByVal modeno As MODE)
        Select Case modeno
            Case MODE.OPEN
                Button1.Enabled = False     ' ボタンを使用禁止にする
                Button2.Enabled = True      ' ボタンを使用許可にする
                Button3.Enabled = False     ' ボタンを使用禁止にする
                Button4.Enabled = True      ' ボタンを使用許可にする
                Button47.Enabled = True     '
                Button48.Enabled = False    '
                TextBox1.Enabled = True
                GroupBox1.Enabled = True    ' ボタンを使用許可にする
                GroupBox2.Enabled = True    ' ボタンを使用許可にする
                GroupBox3.Enabled = True    ' ボタンを使用許可にする
                GroupBox4.Enabled = True    ' ボタンを使用許可にする
                ComboBox1.Enabled = False
            Case MODE.CLOSE
                Button1.Enabled = True      ' ボタンを使用許可にする
                Button2.Enabled = False     ' ボタンを使用禁止にする
                Button3.Enabled = True      ' ボタンを使用許可にする
                Button4.Enabled = False     ' ボタンを使用禁止にする
                Button47.Enabled = False     '
                Button48.Enabled = False    '
                TextBox1.Enabled = False

                GroupBox1.Enabled = False   ' ボタンを使用禁止にする
                GroupBox2.Enabled = False   ' ボタンを使用禁止にする
                GroupBox3.Enabled = False   ' ボタンを使用禁止にする
                GroupBox4.Enabled = False   ' ボタンを使用禁止にする
                ComboBox1.Enabled = True
            Case MODE.TIMER
                Button1.Enabled = False      ' ボタンを使用許可にする
                Button2.Enabled = False     ' ボタンを使用禁止にする
                Button3.Enabled = False      ' ボタンを使用許可にする
                Button4.Enabled = False     ' ボタンを使用禁止にする
                Button47.Enabled = False     '
                Button48.Enabled = True    '
                TextBox1.Enabled = False

                GroupBox1.Enabled = False   ' ボタンを使用禁止にする
                GroupBox2.Enabled = False   ' ボタンを使用禁止にする
                GroupBox3.Enabled = True   ' ボタンを使用禁止にする
                GroupBox4.Enabled = True   ' ボタンを使用禁止にする
                ComboBox1.Enabled = False
            Case Else

        End Select
    End Sub

    Private Sub Button47_Click(sender As Object, e As EventArgs) Handles Button47.Click
        Timer1.Start()
        EnableSet(MODE.TIMER)
    End Sub

    Private Sub Button48_Click(sender As Object, e As EventArgs) Handles Button48.Click
        Timer1.Stop()
        EnableSet(MODE.OPEN)
    End Sub

End Class
